package com.yanzhu.jh.project.mapper;

import java.util.List;
import com.yanzhu.jh.project.domain.SurProjectBuildNodeData;

/**
 * 项目建设节点数据Mapper接口
 * 
 * @author ruoyi
 * @date 2023-08-07
 */
public interface SurProjectBuildNodeDataMapper 
{
    /**
     * 查询项目建设节点数据
     * 
     * @param id 项目建设节点数据主键
     * @return 项目建设节点数据
     */
    public SurProjectBuildNodeData selectSurProjectBuildNodeDataById(Long id);

    /**
     * 查询项目建设节点数据列表
     * 
     * @param surProjectBuildNodeData 项目建设节点数据
     * @return 项目建设节点数据集合
     */
    public List<SurProjectBuildNodeData> selectSurProjectBuildNodeDataList(SurProjectBuildNodeData surProjectBuildNodeData);

    /**
     * 新增项目建设节点数据
     * 
     * @param surProjectBuildNodeData 项目建设节点数据
     * @return 结果
     */
    public int insertSurProjectBuildNodeData(SurProjectBuildNodeData surProjectBuildNodeData);

    /**
     * 修改项目建设节点数据
     * 
     * @param surProjectBuildNodeData 项目建设节点数据
     * @return 结果
     */
    public int updateSurProjectBuildNodeData(SurProjectBuildNodeData surProjectBuildNodeData);

    /**
     * 删除项目建设节点数据
     * 
     * @param id 项目建设节点数据主键
     * @return 结果
     */
    public int deleteSurProjectBuildNodeDataById(Long id);

    /**
     * 批量删除项目建设节点数据
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSurProjectBuildNodeDataByIds(Long[] ids);

    /**
     * 节点计划预警
     * @param where
     * @return
     */
    public List<SurProjectBuildNodeData> selectScheduledAlerts(SurProjectBuildNodeData where);

    /**
     * 获取当前节点及叶子节点
     * @param where
     * @return
     */
    public List<SurProjectBuildNodeData> selectCurrent(SurProjectBuildNodeData where);

    public List<SurProjectBuildNodeData> countCompletionRate(SurProjectBuildNodeData where);

    public List<SurProjectBuildNodeData> queryByProjectType(long type);
}
